Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.eclipse.jdt.core
Interface ICompilationUnit

All Superinterfaces:
  IAdaptable, ICodeAssist, IJavaElement, IOpenable, IParent, ISourceManipulation, ISourceReference, IWorkingCopy

public interface ICompilationUnit
extends IJavaElement, ISourceReference, IParent, IOpenable, IWorkingCopy, ISourceManipulation, ICodeAssist

Represents an entire Java compilation unit (`.java` source file). Compilation unit elements need to be opened before they can be navigated or manipulated. The children are of type `IPackageDeclaration`, `IImportContainer`, and `IType`, and appear in the order in which they are declared in the source. If a `.java` file cannot be parsed, its structure remains unknown. Use `IJavaElement.isStructureKnown` to determine whether this is the case.

This interface is not intended to be implemented by clients.

Field Summary
`static int` | `NO_AST` Constant indicating that a reconcile operation should not return an AST.

Fields inherited from interface org.eclipse.jdt.core.IJavaElement
`CLASS_FILE, COMPILATION_UNIT, FIELD, IMPORT_CONTAINER, IMPORT_DECLARATION, INITIALIZER, JAVA_MODEL, JAVA_PROJECT, LOCAL_VARIABLE, METHOD, PACKAGE_DECLARATION, PACKAGE_FRAGMENT, PACKAGE_FRAGMENT_ROOT, TYPE`

Method Summary
`void` | `becomeWorkingCopy(IProblemRequestor problemRequestor, IProgressMonitor monitor)` Changes this compilation unit handle into a working copy.
`void` | `commitWorkingCopy(boolean force, IProgressMonitor monitor)` Commits the contents of this working copy to its underlying resource.
`IImportDeclaration` | `createImport(String name, IJavaElement sibling, int flags, IProgressMonitor monitor)` Creates and returns an import declaration in this compilation unit with the given name.
`IImportDeclaration` | `createImport(String name, IJavaElement sibling, IProgressMonitor monitor)` Creates and returns an non-static import declaration in this compilation unit with the given name.
`IPackageDeclaration` | `createPackageDeclaration(String name, IProgressMonitor monitor)` Creates and returns a package declaration in this compilation unit with the given package name.
`IType` | `createType(String contents, IJavaElement sibling, boolean force, IProgressMonitor monitor)` Creates and returns a type in this compilation unit with the given contents.
`void` | `discardWorkingCopy()` Changes this compilation unit in working copy mode back to its original mode.
`IJavaElement[]` | `findElements(IJavaElement element)` Finds the elements in this compilation unit that correspond to the given element.
`IType` | `findPrimaryType()` Finds the primary type of this compilation unit (that is, the type with the same name as the compilation unit), or `null` if no such a type exists.
`ICompilationUnit` | `findWorkingCopy(WorkingCopyOwner owner)` Finds the working copy for this compilation unit, given a `WorkingCopyOwner`.
`IType[]` | `getAllTypes()` Returns all types declared in this compilation unit in the order in which they appear in the source.
`IJavaElement` | `getElementAt(int position)` Returns the smallest element within this compilation unit that includes the given source position (that is, a method, field, etc.), or `null` if there is no element other than the compilation unit itself at the given position, or if the given position is not within the source range of this compilation unit.
`IImportDeclaration` | `getImport(String name)` Returns the first import declaration in this compilation unit with the given name.
`IImportContainer` | `getImportContainer()` Returns the import container for this compilation unit.
`IImportDeclaration[]` | `getImports()` Returns the import declarations in this compilation unit in the order in which they appear in the source.
`WorkingCopyOwner` | `getOwner()` Returns the working copy owner of this working copy.
`IPackageDeclaration` | `getPackageDeclaration(String name)` Returns the first package declaration in this compilation unit with the given package name (there normally is at most one package declaration).
`IPackageDeclaration[]` | `getPackageDeclarations()` Returns the package declarations in this compilation unit in the order in which they appear in the source.
`ICompilationUnit` | `getPrimary()` Returns the primary compilation unit (whose owner is the primary owner) this working copy was created from, or this compilation unit if this a primary compilation unit.
`IType` | `getType(String name)` Returns the top-level type declared in this compilation unit with the given simple type name.
`IType[]` | `getTypes()` Returns the top-level types declared in this compilation unit in the order in which they appear in the source.
`ICompilationUnit` | `getWorkingCopy(IProgressMonitor monitor)` Returns a new working copy of this compilation unit if it is a primary compilation unit, or this compilation unit if it is already a non-primary working copy.
`ICompilationUnit` | `getWorkingCopy(WorkingCopyOwner owner, IProblemRequestor problemRequestor, IProgressMonitor monitor)` Returns a shared working copy on this compilation unit using the given working copy owner to create the buffer, or this compilation unit if it is already a non-primary working copy.
`boolean` | `hasResourceChanged()` Returns whether the resource of this working copy has changed since the inception of this working copy.
`boolean` | `isWorkingCopy()` Returns whether this element is a working copy.
`CompilationUnit` | `reconcile(int astLevel, boolean forceProblemDetection, WorkingCopyOwner owner, IProgressMonitor monitor)` Reconciles the contents of this working copy, sends out a Java delta notification indicating the nature of the change of the working copy since the last time it was either reconciled or made consistent (see `IOpenable#makeConsistent()`), and returns a compilation unit AST if requested.
`void` | `restore()` Restores the contents of this working copy to the current contents of this working copy's original element.

Methods inherited from interface org.eclipse.jdt.core.IJavaElement
`exists, getAncestor, getCorrespondingResource, getElementName, getElementType, getHandleIdentifier, getJavaModel, getJavaProject, getOpenable, getParent, getPath, getPrimaryElement, getResource, getSchedulingRule, getUnderlyingResource, isReadOnly, isStructureKnown`

Methods inherited from interface org.eclipse.core.runtime.IAdaptable
`getAdapter`

Methods inherited from interface org.eclipse.jdt.core.ISourceReference
`exists, getSource, getSourceRange`

Methods inherited from interface org.eclipse.jdt.core.IParent
`getChildren, hasChildren`

Methods inherited from interface org.eclipse.jdt.core.IOpenable
`close, getBuffer, hasUnsavedChanges, isConsistent, isOpen, makeConsistent, open, save`

Methods inherited from interface org.eclipse.jdt.core.IWorkingCopy
`commit, destroy, findSharedWorkingCopy, getOriginal, getOriginalElement, getSharedWorkingCopy, getWorkingCopy, getWorkingCopy, isBasedOn, reconcile, reconcile`

Methods inherited from interface org.eclipse.jdt.core.ISourceManipulation
`copy, delete, move, rename`

Methods inherited from interface org.eclipse.jdt.core.ICodeAssist
`codeComplete, codeComplete, codeComplete, codeComplete, codeComplete, codeSelect, codeSelect`

Field Detail

### NO_AST

    public static final int NO_AST

  Constant indicating that a reconcile operation should not return an AST.

  Since:
    3.0
  See Also:
    Constant Field Values

Method Detail

### becomeWorkingCopy

    public void becomeWorkingCopy(IProblemRequestor problemRequestor,
                                  IProgressMonitor monitor)
                           throws JavaModelException

  Changes this compilation unit handle into a working copy. A new `IBuffer` is created using this compilation unit handle's owner. Uses the primary owner is none was specified when this compilation unit handle was created.

  When switching to working copy mode, problems are reported to given `IProblemRequestor`.

  Once in working copy mode, changes to this compilation unit or its children are done in memory. Only the new buffer is affected. Using `commitWorkingCopy(boolean, IProgressMonitor)` will bring the underlying resource in sync with this compilation unit.

  If this compilation unit was already in working copy mode, an internal counter is incremented and no other action is taken on this compilation unit. To bring this compilation unit back into the original mode (where it reflects the underlying resource), `discardWorkingCopy` must be call as many times as `becomeWorkingCopy`.

  Parameters:
    `problemRequestor` - a requestor which will get notified of problems detected during reconciling as they are discovered. The requestor can be set to `null` indicating that the client is not interested in problems.
    `monitor` - a progress monitor used to report progress while opening this compilation unit or `null` if no progress should be reported
  Throws:
    `JavaModelException` - if this compilation unit could not become a working copy.
  Since:
    3.0
  See Also:
    `discardWorkingCopy()`

### commitWorkingCopy

    public void commitWorkingCopy(boolean force,
                                  IProgressMonitor monitor)
                           throws JavaModelException

  Commits the contents of this working copy to its underlying resource.

  It is possible that the contents of the original resource have changed since this working copy was created, in which case there is an update conflict. The value of the `force` parameter effects the resolution of such a conflict:

  - `true` - in this case the contents of this working copy are applied to the underlying resource even though this working copy was created before a subsequent change in the resource
  - `false` - in this case a `JavaModelException` is thrown

  Since 2.1, a working copy can be created on a not-yet existing compilation unit. In particular, such a working copy can then be committed in order to create the corresponding compilation unit.

  Parameters:
    `force` - a flag to handle the cases when the contents of the original resource have changed since this working copy was created
    `monitor` - the given progress monitor
  Throws:
    `JavaModelException` - if this working copy could not commit. Reasons include:
    - A `CoreException` occurred while updating an underlying resource
    - This element is not a working copy (INVALID_ELEMENT_TYPES)
    - A update conflict (described above) (UPDATE_CONFLICT)
  Since:
    3.0

### createImport

    public IImportDeclaration createImport(String name,
                                           IJavaElement sibling,
                                           IProgressMonitor monitor)
                                    throws JavaModelException

  Creates and returns an non-static import declaration in this compilation unit with the given name. This method is equivalent to `createImport(name, Flags.AccDefault, sibling, monitor)`.

  Parameters:
    `name` - the name of the import declaration to add as defined by JLS2 7.5. (For example: `"java.io.File"` or `"java.awt.*"`)
    `sibling` - the existing element which the import declaration will be inserted immediately before (if `null` , then this import will be inserted as the last import declaration.
    `monitor` - the progress monitor to notify
  Returns:
    the newly inserted import declaration (or the previously existing one in case attempting to create a duplicate)
  Throws:
    `JavaModelException` - if the element could not be created. Reasons include:
    - This Java element does not exist or the specified sibling does not exist (ELEMENT_DOES_NOT_EXIST)
    - A `CoreException` occurred while updating an underlying resource
    - The specified sibling is not a child of this compilation unit (INVALID_SIBLING)
    - The name is not a valid import name (INVALID_NAME)
  See Also:
    `createImport(String, IJavaElement, int, IProgressMonitor)`

### createImport

    public IImportDeclaration createImport(String name,
                                           IJavaElement sibling,
                                           int flags,
                                           IProgressMonitor monitor)
                                    throws JavaModelException

  Creates and returns an import declaration in this compilation unit with the given name.

  Optionally, the new element can be positioned before the specified sibling. If no sibling is specified, the element will be inserted as the last import declaration in this compilation unit.

  If the compilation unit already includes the specified import declaration, the import is not generated (it does not generate duplicates). Note that it is valid to specify both a single-type import and an on-demand import for the same package, for example `"java.io.File"` and `"java.io.*"`, in which case both are preserved since the semantics of this are not the same as just importing `"java.io.*"`. Importing `"java.lang.*"`, or the package in which the compilation unit is defined, are not treated as special cases. If they are specified, they are included in the result.

  Note: This API element is only needed for dealing with Java code that uses new language features of J2SE 1.5. It is included in anticipation of J2SE 1.5 support, which is planned for the next release of Eclipse after 3.0, and may change slightly before reaching its final form.

  Parameters:
    `name` - the name of the import declaration to add as defined by JLS2 7.5. (For example: `"java.io.File"` or `"java.awt.*"`)
    `sibling` - the existing element which the import declaration will be inserted immediately before (if `null` , then this import will be inserted as the last import declaration.
    `flags` - `Flags.AccStatic` for static imports, or `Flags.AccDefault` for regular imports; other modifier flags are ignored
    `monitor` - the progress monitor to notify
  Returns:
    the newly inserted import declaration (or the previously existing one in case attempting to create a duplicate)
  Throws:
    `JavaModelException` - if the element could not be created. Reasons include:
    - This Java element does not exist or the specified sibling does not exist (ELEMENT_DOES_NOT_EXIST)
    - A `CoreException` occurred while updating an underlying resource
    - The specified sibling is not a child of this compilation unit (INVALID_SIBLING)
    - The name is not a valid import name (INVALID_NAME)
  Since:
    3.0
  See Also:
    `Flags`

### createPackageDeclaration

    public IPackageDeclaration createPackageDeclaration(String name,
                                                        IProgressMonitor monitor)
                                                 throws JavaModelException

  Creates and returns a package declaration in this compilation unit with the given package name.

  If the compilation unit already includes the specified package declaration, it is not generated (it does not generate duplicates).

  Parameters:
    `name` - the name of the package declaration to add as defined by JLS2 7.4. (For example, `"java.lang"`)
    `monitor` - the progress monitor to notify
  Returns:
    the newly inserted package declaration (or the previously existing one in case attempting to create a duplicate)
  Throws:
    `JavaModelException` - if the element could not be created. Reasons include:
    - This Java element does not exist (ELEMENT_DOES_NOT_EXIST)
    - A `CoreException` occurred while updating an underlying resource
    - The name is not a valid package name (INVALID_NAME)

### createType

    public IType createType(String contents,
                            IJavaElement sibling,
                            boolean force,
                            IProgressMonitor monitor)
                     throws JavaModelException

  Creates and returns a type in this compilation unit with the given contents. If this compilation unit does not exist, one will be created with an appropriate package declaration.

  Optionally, the new type can be positioned before the specified sibling. If `sibling` is `null`, the type will be appended to the end of this compilation unit.

  It is possible that a type with the same name already exists in this compilation unit. The value of the `force` parameter effects the resolution of such a conflict:

  - `true` - in this case the type is created with the new contents
  - `false` - in this case a `JavaModelException` is thrown

  Parameters:
    `contents` - the source contents of the type declaration to add.
    `sibling` - the existing element which the type will be inserted immediately before (if `null` , then this type will be inserted as the last type declaration.
    `force` - a `boolean` flag indicating how to deal with duplicates
    `monitor` - the progress monitor to notify
  Returns:
    the newly inserted type
  Throws:
    `JavaModelException` - if the element could not be created. Reasons include:
    - The specified sibling element does not exist (ELEMENT_DOES_NOT_EXIST)
    - A `CoreException` occurred while updating an underlying resource
    - The specified sibling is not a child of this compilation unit (INVALID_SIBLING)
    - The contents could not be recognized as a type declaration (INVALID_CONTENTS)
    - There was a naming collision with an existing type (NAME_COLLISION)

### discardWorkingCopy

    public void discardWorkingCopy()
                            throws JavaModelException

  Changes this compilation unit in working copy mode back to its original mode.

  This has no effect if this compilation unit was not in working copy mode.

  If `becomeWorkingCopy` was called several times on this compilation unit, `discardWorkingCopy` must be called as many times before it switches back to the original mode.

  Throws:
    `JavaModelException` - if this working copy could not return in its original mode.
  Since:
    3.0
  See Also:
    `becomeWorkingCopy(IProblemRequestor, IProgressMonitor)`

### findElements

    public IJavaElement[] findElements(IJavaElement element)

  Finds the elements in this compilation unit that correspond to the given element. An element A corresponds to an element B if:
  - A has the same element name as B.
  - If A is a method, A must have the same number of arguments as B and the simple names of the argument types must be equals.
  - The parent of A corresponds to the parent of B recursively up to their respective compilation units.
  - A exists.
  Returns `null` if no such java elements can be found or if the given element is not included in a compilation unit.

  Specified by:
    `findElements` in interface `IWorkingCopy`
  Parameters:
    `element` - the given element
  Returns:
    the found elements in this compilation unit that correspond to the given element
  Since:
    3.0

### findPrimaryType

    public IType findPrimaryType()

  Finds the primary type of this compilation unit (that is, the type with the same name as the compilation unit), or `null` if no such a type exists.

  Specified by:
    `findPrimaryType` in interface `IWorkingCopy`
  Returns:
    the found primary type of this compilation unit, or `null` if no such a type exists
  Since:
    3.0

### findWorkingCopy

    public ICompilationUnit findWorkingCopy(WorkingCopyOwner owner)

  Finds the working copy for this compilation unit, given a `WorkingCopyOwner`. If no working copy has been created for this compilation unit associated with this working copy owner, returns `null`.

  Users of this method must not destroy the resulting working copy.

  Parameters:
    `owner` - the given `WorkingCopyOwner`
  Returns:
    the found working copy for this compilation unit, `null` if none
  Since:
    3.0
  See Also:
    `WorkingCopyOwner`

### getAllTypes

    public IType[] getAllTypes()
                        throws JavaModelException

  Returns all types declared in this compilation unit in the order in which they appear in the source. This includes all top-level types and nested member types. It does NOT include local types (types defined in methods).

  Returns:
    the array of top-level and member types defined in a compilation unit, in declaration order.
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource

### getElementAt

    public IJavaElement getElementAt(int position)
                              throws JavaModelException

  Returns the smallest element within this compilation unit that includes the given source position (that is, a method, field, etc.), or `null` if there is no element other than the compilation unit itself at the given position, or if the given position is not within the source range of this compilation unit.

  Parameters:
    `position` - a source position inside the compilation unit
  Returns:
    the innermost Java element enclosing a given source position or `null` if none (excluding the compilation unit).
  Throws:
    `JavaModelException` - if the compilation unit does not exist or if an exception occurs while accessing its corresponding resource

### getImport

    public IImportDeclaration getImport(String name)

  Returns the first import declaration in this compilation unit with the given name. This is a handle-only method. The import declaration may or may not exist. This is a convenience method - imports can also be accessed from a compilation unit's import container.

  Parameters:
    `name` - the name of the import to find as defined by JLS2 7.5. (For example: `"java.io.File"` or `"java.awt.*"`)
  Returns:
    a handle onto the corresponding import declaration. The import declaration may or may not exist.

### getImportContainer

    public IImportContainer getImportContainer()

  Returns the import container for this compilation unit. This is a handle-only method. The import container may or may not exist. The import container can used to access the imports.

  Returns:
    a handle onto the corresponding import container. The import contain may or may not exist.

### getImports

    public IImportDeclaration[] getImports()
                                    throws JavaModelException

  Returns the import declarations in this compilation unit in the order in which they appear in the source. This is a convenience method - import declarations can also be accessed from a compilation unit's import container.

  Returns:
    the import declarations in this compilation unit
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource

### getPrimary

    public ICompilationUnit getPrimary()

  Returns the primary compilation unit (whose owner is the primary owner) this working copy was created from, or this compilation unit if this a primary compilation unit.

  Note that the returned primary compilation unit can be in working copy mode.

  Returns:
    the primary compilation unit this working copy was created from, or this compilation unit if it is primary
  Since:
    3.0

### getOwner

    public WorkingCopyOwner getOwner()

  Returns the working copy owner of this working copy. Returns null if it is not a working copy or if it has no owner.

  Returns:
    WorkingCopyOwner the owner of this working copy or `null`
  Since:
    3.0

### getPackageDeclaration

    public IPackageDeclaration getPackageDeclaration(String name)

  Returns the first package declaration in this compilation unit with the given package name (there normally is at most one package declaration). This is a handle-only method. The package declaration may or may not exist.

  Parameters:
    `name` - the name of the package declaration as defined by JLS2 7.4. (For example, `"java.lang"`)
  Returns:
    the first package declaration in this compilation unit with the given package name

### getPackageDeclarations

    public IPackageDeclaration[] getPackageDeclarations()
                                                 throws JavaModelException

  Returns the package declarations in this compilation unit in the order in which they appear in the source. There normally is at most one package declaration.

  Returns:
    an array of package declaration (normally of size one)
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource

### getType

    public IType getType(String name)

  Returns the top-level type declared in this compilation unit with the given simple type name. The type name has to be a valid compilation unit name. This is a handle-only method. The type may or may not exist.

  Parameters:
    `name` - the simple name of the requested type in the compilation unit
  Returns:
    a handle onto the corresponding type. The type may or may not exist.
  See Also:
    `JavaConventions.validateCompilationUnitName(String name)`

### getTypes

    public IType[] getTypes()
                     throws JavaModelException

  Returns the top-level types declared in this compilation unit in the order in which they appear in the source.

  Returns:
    the top-level types declared in this compilation unit
  Throws:
    `JavaModelException` - if this element does not exist or if an exception occurs while accessing its corresponding resource

### getWorkingCopy

    public ICompilationUnit getWorkingCopy(IProgressMonitor monitor)
                                    throws JavaModelException

  Returns a new working copy of this compilation unit if it is a primary compilation unit, or this compilation unit if it is already a non-primary working copy.

  Note: if intending to share a working copy amongst several clients, then `#getWorkingCopy(WorkingCopyOwner, IProblemRequestor, IProgressMonitor)` should be used instead.

  When the working copy instance is created, an ADDED IJavaElementDelta is reported on this working copy.

  Once done with the working copy, users of this method must discard it using `discardWorkingCopy()`.

  Since 2.1, a working copy can be created on a not-yet existing compilation unit. In particular, such a working copy can then be committed in order to create the corresponding compilation unit.

  Parameters:
    `monitor` - a progress monitor used to report progress while opening this compilation unit or `null` if no progress should be reported
  Returns:
    a new working copy of this element if this element is not a working copy, or this element if this element is already a working copy
  Throws:
    `JavaModelException` - if the contents of this element can not be determined.
  Since:
    3.0

### getWorkingCopy

    public ICompilationUnit getWorkingCopy(WorkingCopyOwner owner,
                                           IProblemRequestor problemRequestor,
                                           IProgressMonitor monitor)
                                    throws JavaModelException

  Returns a shared working copy on this compilation unit using the given working copy owner to create the buffer, or this compilation unit if it is already a non-primary working copy. This API can only answer an already existing working copy if it is based on the same original compilation unit AND was using the same working copy owner (that is, as defined by `Object.equals`).

  The life time of a shared working copy is as follows:

  - The first call to `getWorkingCopy(WorkingCopyOwner, IProblemRequestor, IProgressMonitor)` creates a new working copy for this element
  - Subsequent calls increment an internal counter.
  - A call to `discardWorkingCopy()` decrements the internal counter.
  - When this counter is 0, the working copy is discarded.
  So users of this method must discard exactly once the working copy.

  Note that the working copy owner will be used for the life time of this working copy, that is if the working copy is closed then reopened, this owner will be used. The buffer will be automatically initialized with the original's compilation unit content upon creation.

  When the shared working copy instance is created, an ADDED IJavaElementDelta is reported on this working copy.

  Since 2.1, a working copy can be created on a not-yet existing compilation unit. In particular, such a working copy can then be committed in order to create the corresponding compilation unit.

  Parameters:
    `owner` - the working copy owner that creates a buffer that is used to get the content of the working copy
    `problemRequestor` - a requestor which will get notified of problems detected during reconciling as they are discovered. The requestor can be set to `null` indicating that the client is not interested in problems.
    `monitor` - a progress monitor used to report progress while opening this compilation unit or `null` if no progress should be reported
  Returns:
    a new working copy of this element using the given factory to create the buffer, or this element if this element is already a working copy
  Throws:
    `JavaModelException` - if the contents of this element can not be determined.
  Since:
    3.0

### hasResourceChanged

    public boolean hasResourceChanged()

  Returns whether the resource of this working copy has changed since the inception of this working copy. Returns `false` if this compilation unit is not in working copy mode.

  Returns:
    whether the resource has changed
  Since:
    3.0

### isWorkingCopy

    public boolean isWorkingCopy()

  Returns whether this element is a working copy.

  Specified by:
    `isWorkingCopy` in interface `IWorkingCopy`
  Returns:
    true if this element is a working copy, false otherwise
  Since:
    3.0

### reconcile

    public CompilationUnit reconcile(int astLevel,
                                     boolean forceProblemDetection,
                                     WorkingCopyOwner owner,
                                     IProgressMonitor monitor)
                              throws JavaModelException

  Reconciles the contents of this working copy, sends out a Java delta notification indicating the nature of the change of the working copy since the last time it was either reconciled or made consistent (see `IOpenable#makeConsistent()`), and returns a compilation unit AST if requested.

  It performs the reconciliation by locally caching the contents of the working copy, updating the contents, then creating a delta over the cached contents and the new contents, and finally firing this delta.

  The boolean argument allows to force problem detection even if the working copy is already consistent.

  This functionality allows to specify a working copy owner which is used during problem detection. All references contained in the working copy are resolved against other units; for which corresponding owned working copies are going to take precedence over their original compilation units. If `null` is passed in, then the primary working copy owner is used.

  Compilation problems found in the new contents are notified through the `IProblemRequestor` interface which was passed at creation, and no longer as transient markers.

  Note: Since 3.0, added/removed/changed inner types generate change deltas.

  If requested, a DOM AST representing the compilation unit is returned. Its bindings are computed only if the problem requestor is active, or if the problem detection is forced. This method returns `null` if the creation of the DOM AST was not requested, or if the requested level of AST API is not supported, or if the working copy was already consistent.

  NOTE:In Eclipse 3.0, there is no reconciler support for level AST.JLS3. This support is planned for the follow-on release of Eclipse which includes support for J2SE 1.5.

  Parameters:
    `astLevel` - either `NO_AST` if no AST is wanted, or the AST API level of the AST if one is wanted
    `forceProblemDetection` - boolean indicating whether problem should be recomputed even if the source hasn't changed
    `owner` - the owner of working copies that take precedence over the original compilation units, or `null` if the primary working copy owner should be used
    `monitor` - a progress monitor
  Returns:
    the compilation unit AST or `null` if not requested, or if the requested level of AST API is not supported, or if the working copy was consistent
  Throws:
    `JavaModelException` - if the contents of the original element cannot be accessed. Reasons include:
    - The original Java element does not exist (ELEMENT_DOES_NOT_EXIST)
  Since:
    3.0

### restore

    public void restore()
                 throws JavaModelException

  Restores the contents of this working copy to the current contents of this working copy's original element. Has no effect if this element is not a working copy.

  Note: This is the inverse of committing the content of the working copy to the original element with `commit(boolean, IProgressMonitor)`.

  Specified by:
    `restore` in interface `IWorkingCopy`
  Throws:
    `JavaModelException` - if the contents of the original element cannot be accessed. Reasons include:
    - The original Java element does not exist (ELEMENT_DOES_NOT_EXIST)
  Since:
    3.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Eclipse JDT Release 3.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) IBM Corp. and others 2000, 2004. All Rights Reserved.